import { IDeserializer, IIterableAccess, IMapAccess, IVisitor } from './interface';
export declare class GenericSeed<T> {
    readonly visitor: IVisitor<T>;
    constructor(visitor?: IVisitor<T>);
    static deserialize<T, D extends IDeserializer>(deserializer: D, visitor?: IVisitor<T>): T;
    deserialize<D extends IDeserializer>(deserializer: D): T;
}
export declare class GenericVisitor<T> implements IVisitor<T> {
    visitBoolean(value: boolean): T;
    visitNumber(value: number): T;
    visitBigInt(value: bigint): T;
    visitString(value: string): T;
    visitSymbol(value: symbol): T;
    visitNull(): T;
    visitObject(access: IMapAccess): T;
    visitIterable(access: IIterableAccess): T;
}
