"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IterableAccess = exports.MapAccess = void 0;
const utils_1 = require("../utils");
class MapAccess {
    nextEntrySeed(kseed, vseed) {
        const key = this.nextKeySeed(kseed);
        if (!key.done) {
            const value = this.nextValueSeed(vseed);
            if (!value.done) {
                return utils_1.IterResult.Next([key.value, value.value]);
            }
        }
        return utils_1.IterResult.Done();
    }
    nextEntry() {
        const key = this.nextKey();
        if (!key.done) {
            const value = this.nextValue();
            if (!value.done) {
                return utils_1.IterResult.Next([key.value, value.value]);
            }
        }
        return utils_1.IterResult.Done();
    }
}
exports.MapAccess = MapAccess;
class IterableAccess {
}
exports.IterableAccess = IterableAccess;
