export type Nullable<T> = T | undefined;
export interface Morphism<T = any, U = any> {
    (value: T): U;
}
export type Primitive = string | number | boolean | symbol | bigint | null | undefined;
export interface ToString {
    toString(): string;
}
export declare function staticImplements<T>(): <U extends T>(constructor: U) => void;
export declare function isPlainObject(value: any): boolean;
export declare function isFunction(value: any): value is Function;
export declare function isIterable(value: any): value is Iterable<any>;
export declare function isString(value: any): value is string;
export declare function isNumber(value: any): value is number;
export type Constructor<T = any> = new (...args: any[]) => T;
export declare class IterResult {
    static Next<T>(value: T): IteratorResult<T>;
    static Done<T>(): IteratorResult<T>;
}
